
if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create
GO


Create procedure dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create
	@taskid uniqueidentifier,
	@table nvarchar ( 100 ) = '',
	@query nvarchar ( 4000 ) = '',
	@colid nvarchar ( 100 ),
	@colsphone nvarchar ( 1000 )
	
as
begin


------------------------------------------------------------

--declare @table nvarchar ( 100 )
--declare @colid nvarchar ( 100 )
--declare @taskid uniqueidentifier
--declare @colsphone nvarchar ( 1000 )
--declare @query nvarchar ( 4000 )

--Select @taskid = '2E170DDF-CFFF-4571-A058-A9DD2629D8B1', @colid = N'Id', @colsphone = N' IsNull ( [Phone], '''' ) ', @table = N'dbo.[A_TaskManager_LocalList_982b3182-d7c5-453f-8e75-af837e61eba7_0]'

----------------------------------------------------------

	declare @temptable nvarchar (100 )
	set @temptable = 'dbo.[t_cache1_' + cast ( @taskid as nvarchar (100 ) ) + ']'

	declare @temptable2 nvarchar (100 )
	set @temptable2 = 'dbo.[t_cache2_' + cast ( @taskid as nvarchar (100 ) ) + ']'

	declare @tableidx nvarchar (100), @tableidxconstr nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	set @tableidxconstr = 'A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) )
	


	declare @sql nvarchar ( 4000 )

	----------------------

	set @sql = '
		If not exists ( select * FROM sysobjects where id = object_id ( ''' + @tableidx + ''' ) )
			Create Table ' + @tableidx + ' ( id int not null, Phone nvarchar ( 50 ) not null )
		'

	exec sp_executesql @sql

	set @sql = '
		if not exists ( select s.name, s.parent_obj, s1.name from sysobjects s
			inner join sysobjects s1 on s.parent_obj = s1.Id where s.name like ''PK_' + @tableidxconstr + ''' )
			ALTER TABLE ' + @tableidx + ' ADD CONSTRAINT [PK_' + @tableidxconstr + '] PRIMARY KEY CLUSTERED 
			( [Id], [Phone] )  ON [PRIMARY] 
		'
			
	exec sp_executesql @sql

	set @sql = 'Truncate table ' + @tableidx

	exec sp_executesql @sql

	----------------------
	
	begin tran CreateIdNumCache

	----------------------

	set @sql = '
	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable + ''' ) )
			drop table ' + @temptable + ' 
		'

	exec sp_executesql @sql
	
	----------------------

	set @sql = '
	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable2 + ''' ) )
			drop table ' + @temptable2 + ' 
		'

	exec sp_executesql @sql
	
	-----------------------

	--  ?
	Declare @spacesep bit
	Select @spacesep = case when ( valueint = 1 ) then 1 else 0 end
	From A_Settings 
	Where [name] like 'us~~~~b_UseDividerSpaceInNumbers'
	
	-----------------------------------

	declare @dt datetime, @dt1 datetime
	set @dt = GetDate()

	set @sql = '
		Select ' + @colid + ' as Id,
			Replace ( Replace ( Replace (
			Replace ( Replace ( Replace ( 
			Replace ( Replace ( Replace (
			Replace ( Replace (
				''^'' + ' + @colsphone + ' + ''$'', 
				''^, '', ''^'' ), ''^, '', ''^'' ), ''^, '', ''^'' ),
				'', $'', ''$'' ), '', $'', ''$'' ), '', $'', ''$'' ),
				'', ,'', '', ''), '', ,'', '', ''), '', ,'', '', ''),
			''^'', '''' ), ''$'', '''' ) as Phone into ' + @temptable + '
		From '
	if ( Len ( @table ) > 0 )
		set @sql = @sql + @table
	else
		set @sql = @sql + '( ' + @query + ' )a'
		
	exec sp_executesql @sql

	----------------------

	-- TEST
	--set @sql = 'Select * FROM ' + @temptable 
	--exec sp_executesql @sql

	----------------------

	declare @tt nvarchar ( 100 )
	set @tt = @temptable

	Select @sql = '
		Insert into ' + @tableidx + '
			Select * From ' + @tt + ' 
			Where not Phone like ''%,%'' 
				and not Phone like ''%;%''' +
				case when ( @spacesep = 1 ) then '
				and not Phone like ''% %''' else '' end + '
				and not Phone like ''''
		'

	exec sp_executesql @sql


--	set @dt1 = GetDate() - @dt
--	print 'part3     ' + cast ( DatePart ( hh, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( mi, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ss, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ms, @dt1 ) as nvarchar ( 10 ) )


	Select @sql = '
		Declare @sep table ( sep nvarchar(10), sepindex int )
		Insert into @sep ( sep, sepindex ) Values ( '','', null )
		Insert into @sep ( sep, sepindex ) Values ( '';'', null ) ' + 
		case when ( @spacesep = 1 ) then '
		Insert into @sep ( sep, sepindex ) Values ( '' '', null ) ' else '' end + '
		
		Declare ucursor Cursor LOCAL FAST_FORWARD For 
			Select Id, Phone From ' + @tt + ' Where Phone like ''%,%'' or Phone like ''%;%''

		declare @id int, @phone nvarchar ( 1000 )

		Open ucursor
		Fetch Next From ucursor Into @id, @phone

		While ( @@fetch_status = 0 )
		   begin	
			declare @i int, @j1 int, @j2 int, 
				@j2_1 int, @j2_2 int,
				@ph nvarchar ( 50 )
	
			set @i = 0
			set @j1 = 1
			set @j2 = 0
			
			set @j2_1 = 0
			set @j2_2 = 0
			
			--set @j2_1 = charindex ( '','', @phone, @j1 ) 
			--set @j2_2 = charindex ( '';'', @phone, @j1 )
			--if (( @j2_1 < @j2_2 ) and ( @j2_1 > 0 )) or ( @j2_2 <= 0 )
			--	set @j2 = @j2_1
			--else
			--	set @j2 = @j2_2
			Update @sep 
			Set sepindex = charindex ( sep, @phone, @j1 ) 
			Select @j2 = min ( sepindex ) From @sep Where sepindex > 0
			
			while @j2 > 0 or @i = 0
			begin		
				if ( @j2 = 0 )
				begin
					set @j2 = len ( @phone ) + 1
					set @i = 1
				end
	
				select @ph = REPLACE ( REPLACE ( REPLACE ( REPLACE ( 
					LTRIM ( RTRIM ( substring ( @phone, @j1, @j2-@j1 ) ) ), 
					'' '', '''' ), ''('', '''' ), '')'', '''' ), ''-'', '''' )

				if ( Len ( @ph ) > 0 )
					if not exists ( select id from ' + @tableidx + ' where id = @id and Phone = @ph )
						Insert into ' + @tableidx + ' Values ( @id, @ph )

				select @j1 = @j2 + 1, @j2 = 0
				
				set @j2_1 = charindex ( '','', @phone, @j1 ) 
				set @j2_2 = charindex ( '';'', @phone, @j1 )
				if (( @j2_1 < @j2_2 ) and ( @j2_1 > 0 )) or ( @j2_2 <= 0 )
					set @j2 = @j2_1
				else
					set @j2 = @j2_2
			end
	
	

			Fetch Next From ucursor Into @id, @phone
		   end

		Close ucursor
		Deallocate ucursor
	'

	exec sp_executesql @sql


--	set @dt1 = GetDate() - @dt
--	print 'part4     ' + cast ( DatePart ( hh, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( mi, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ss, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ms, @dt1 ) as nvarchar ( 10 ) )

	
	----------------------

	set @sql = '	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable + ''' ) )
			drop table ' + @temptable + ' 
		
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable2 + ''' ) )
			drop table ' + @temptable2 + ' 
		'

	exec sp_executesql @sql

	----------------------

	Commit tran CreateIdNumCache


end
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator
GO


Create procedure dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@listtable nvarchar ( 1000 ) = '',
	@listquery nvarchar ( 4000 ) = '',
	@listidfield nvarchar ( 200 ) = '',
	@listnamefield nvarchar ( 200 ) = '',
	@count int = 0,
	@letter1 char ( 1 ) = '',
	@letter2 char ( 1 ) = ''
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''

	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		if ( @count > 0 )
  		    Set @sql = '
			SET ROWCOUNT ' + cast ( @count as nvarchar ( 10 ) ) + '

			Update ' + @tableidx + ' 
			Set IdOperator = ' + @operator + '
			Where IdOperator is null

			SET ROWCOUNT 0
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listtable != '' ) and ( @listnamefield != '' ))
		    Set @sql = '
			Declare @temp table ( id int primary key )
			Insert into @temp 
				Select Distinct ' + @listidfield + ' 
				From ' + @listtable + '
				Where Cast ( Substring ( ' + @listnamefield + ', 1, 1 ) as char ( 1 ) ) between ''' + @letter1 + ''' and ''' + @letter2 + '''
			
			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, @temp b
			Where a.Id = b.Id
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listquery != '' ) and ( @listnamefield != '' ))
		    Set @sql = '
			Declare @temp table ( id int primary key )
			Insert into @temp 
				Select Distinct ' + @listidfield + ' 
				From (' + @listquery + ') a
				Where Cast ( Substring ( ' + @listnamefield + ', 1, 1 ) as char ( 1 ) ) between ''' + @letter1 + ''' and ''' + @letter2 + '''
			
			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, @temp b
			Where a.Id = b.Id
			'

		else 
		    Set @sql = '
			Update ' + @tableidx + ' 
			Set IdOperator = NULL
			Where IdOperator = ''00000000-0000-0000-0000-000000000000'''

			
		exec sp_sqlexec @sql
	end
end
GO
