
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_SubTasks_old' ))
	Drop table dbo.A_TaskManager_SubTasks_old
GO


IF  EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[A_TaskManager_SubTasks]') AND name = N'PK_A_TaskManager_SubTasks_tID_idIL')
	ALTER TABLE [dbo].[A_TaskManager_SubTasks] DROP CONSTRAINT [PK_A_TaskManager_SubTasks_tID_idIL]
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_SubTasks' ))
	exec sp_rename 'dbo.A_TaskManager_SubTasks', 'A_TaskManager_SubTasks_old'
GO


if not exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_SubTasks' ))
CREATE TABLE [dbo].[A_TaskManager_SubTasks]
(
	[IdInList] [int] NOT NULL,
	[TaskId] [uniqueidentifier] NOT NULL,
	[NResult] [int] NOT NULL,
	[IsDeleted] [int] NOT NULL,
	[NextEffortTime] [datetime] NULL,
	[RetryNumbers] [nvarchar](1000) COLLATE database_default NULL,
 
	CONSTRAINT [PK_A_TaskManager_SubTasks_tID_idIL] PRIMARY KEY CLUSTERED 
	(
		[TaskId] ASC,
		[IdInList] ASC
	) 
	WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF, FILLFACTOR = 80) ON [PRIMARY]
) 
ON [PRIMARY]
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_SubTasks_old' ))
	Insert into dbo.A_TaskManager_SubTasks ( IdInList, TaskId, NResult, IsDeleted, NextEffortTime, RetryNumbers )
		Select IdInList, TaskId, NResult, 0, NextEffortTime, RetryNumbers
		From dbo.A_TaskManager_SubTasks_old
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_SubTasks_old' ))
	Drop table dbo.A_TaskManager_SubTasks_old
GO
