if exists ( select * from sysobjects where id=object_id ( 'dbo.A_CallCenter_Report_GetSProcNames' ))
	Drop procedure dbo.A_CallCenter_Report_GetSProcNames
GO

Create Procedure dbo.[A_CallCenter_Report_GetSProcNames]
as
Begin
	begin tran

	create table #res ( id int identity(1,1), namedb varchar(256) collate database_default, namesp varchar(256) collate database_default )

	declare cr_db cursor local FAST_FORWARD READ_ONLY
	FOR 
		select name
		from master..sysdatabases
		where name not in ('master','model','tempdb','msdb') 
			and version is not null

	declare @dbname varchar(255), @spname varchar(255)
	declare @sqltext varchar(1000)
	
	open cr_db

	fetch next from cr_db into @dbname

	while @@fetch_status = 0 begin
	--use @dbname
		set @sqltext = 'insert #res ( namedb, namesp )
	          select ''' + @dbname + ''',name
        	  from ['+ @dbname + ']..sysobjects
	          where xtype = ''P''
        	  order by Name'
		--print @sqltext
		exec sp_sqlexec @sqltext         

		fetch next from cr_db into @dbname
	end

	select * from #res
	drop table #res

	close cr_db
	deallocate cr_db
	commit
End
GO

