If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerExtLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerExtLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'SystemNumStr' )
	Alter Table oktell_settings.dbo.A_ServerExtLines
	Add [SystemNumStr] nvarchar(10)
GO

Update oktell_settings.dbo.A_ServerExtLines
Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
Where SystemNumStr is NULL
GO

-----------------

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerGSMLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerGSMLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'SystemNumStr' )
	Alter Table oktell_settings.dbo.A_ServerGSMLines
	Add [SystemNumStr] nvarchar(10)
GO

Update oktell_settings.dbo.A_ServerGSMLines
Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
Where SystemNumStr is NULL
GO

-----------------

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerIntLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerIntLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'SystemNumStr' )
	Alter Table oktell_settings.dbo.A_ServerIntLines
	Add [SystemNumStr] nvarchar(10)
GO

Update oktell_settings.dbo.A_ServerIntLines
Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
Where SystemNumStr is NULL
GO

-----------------

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerSipLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerSipLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'SystemNumStr' )
	Alter Table oktell_settings.dbo.A_ServerSipLines
	Add [SystemNumStr] nvarchar(10)
GO

Update oktell_settings.dbo.A_ServerSipLines
Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
Where SystemNumStr is NULL
GO

-----------------

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerUSBLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerUSBLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'SystemNumStr' )
	Alter Table oktell_settings.dbo.A_ServerUSBLines
	Add [SystemNumStr] nvarchar(10)
GO

Update oktell_settings.dbo.A_ServerUSBLines
Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
Where SystemNumStr is NULL
GO

-----------------

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerVirtualLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerVirtualLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'SystemNumStr' )
	Alter Table oktell_settings.dbo.A_ServerVirtualLines
	Add [SystemNumStr] nvarchar(10)
GO

Update oktell_settings.dbo.A_ServerVirtualLines
Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
Where SystemNumStr is NULL
GO

-----------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_ServerExtLines' ))
	Drop view dbo.A_ServerExtLines
GO

Create view dbo.A_ServerExtLines
as
	Select * 
	From oktell_settings.dbo.A_ServerExtLines 
GO

------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_ServerGSMLines' ))
	Drop view dbo.A_ServerGSMLines
GO

Create view dbo.A_ServerGSMLines
as
	Select * 
	From oktell_settings.dbo.A_ServerGSMLines 
GO

------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_ServerIntLines' ))
	Drop view dbo.A_ServerIntLines
GO

Create view dbo.A_ServerIntLines
as
	Select * 
	From oktell_settings.dbo.A_ServerIntLines 
GO

------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_ServerSipLines' ))
	Drop view dbo.A_ServerSipLines
GO

Create view dbo.A_ServerSipLines
as
	Select * 
	From oktell_settings.dbo.A_ServerSipLines 
GO

------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_ServerUSBLines' ))
	Drop view dbo.A_ServerUSBLines
GO

Create view dbo.A_ServerUSBLines
as
	Select * 
	From oktell_settings.dbo.A_ServerUSBLines 
GO

------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_ServerVirtualLines' ))
	Drop view dbo.A_ServerVirtualLines
GO

Create view dbo.A_ServerVirtualLines
as
	Select * 
	From oktell_settings.dbo.A_ServerVirtualLines 
GO

------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_View_ServerIntLinesAll' ))
	Drop view dbo.A_View_ServerIntLinesAll
GO

Create View [dbo].[A_View_ServerIntLinesAll]
as
	--    
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, SystemNumStr
	From A_ServerIntLines
	
	Union 

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, SystemNumStr
	From A_ServerUsbLines

	Union
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, SystemNumStr
	From A_ServerSipLines

	Union

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, SystemNumStr
	From A_ServerVirtualLines

GO

------------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_View_ServerLinesAll' ))
	Drop view dbo.A_View_ServerLinesAll
GO

Create View [dbo].[A_View_ServerLinesAll]
as
	--   
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode, SystemNumStr
	From A_ServerExtLines
	
	Union 
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode, SystemNumStr
	From A_ServerGsmLines
	
	Union 

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode, SystemNumStr
	From A_ServerIntLines
	
	Union 

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode, SystemNumStr
	From A_ServerUsbLines

	Union
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode, SystemNumStr
	From A_ServerSipLines

	Union

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode, SystemNumStr
	From A_ServerVirtualLines
GO

---------------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_View_LineStates' ))
	Drop view dbo.A_View_LineStates
GO

Create View dbo.A_View_LineStates
AS
--   
	Select Id, Enabled, Type, OwnerId, React, ServerId, ReactServer, Caption, Connected, SystemNum, LineCode, SystemNumStr
	From ( 
		Select a.Id, a.Enabled, a.Type, a.ServerId as OwnerId, WP1.ID AS react, 
			case WP1.type when 5 then WP1.ID else WP1.parentID end as ServerID , 
			WP1.Type AS reactserver, a.Caption, 0 as connected, 
			a.SystemNum, LineCode, a.SystemNumStr
		
		From A_View_ServerLinesAll a
			Inner Join  dbo.A_LinesReactors LR ON a.ID = LR.LineID 
			Inner Join  dbo.A_WorkPlaces WP1 ON LR.WPID = WP1.ID
		
		
		Union
	
	
		Select a.Id, a.Enabled, a.Type, a.ServerId as OwnerId, null AS React,  
			a.ServerId as ServerId , null AS reactserver, a.Caption, 1 as connected, 
			a.SystemNum, LineCode, a.SystemNumStr
		
		From A_View_ServerLinesAll a 
		Where not a.ID in ( Select LineID From A_LinesReactors )
	)b	

GO

--------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_View_ServerIntLinesDefaultUsers' ))
	Drop view dbo.A_View_ServerIntLinesDefaultUsers
GO

Create View [dbo].[A_View_ServerIntLinesDefaultUsers]
as
	--    ,    WebsockUser  

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId, SystemNumStr
	From A_ServerIntLines
	
	Union 
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId, SystemNumStr
	From A_ServerSipLines

	Union

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId, SystemNumStr
	From A_ServerVirtualLines

GO

-----------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_View_ServerIntLinesWebsockUsers' ))
	Drop view dbo.A_View_ServerIntLinesWebsockUsers
GO

Create View [dbo].[A_View_ServerIntLinesWebsockUsers]
as
	--    ,    WebsockUser  

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId, SystemNumStr
	From A_ServerIntLines
	
	Union 
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId, SystemNumStr
	From A_ServerSipLines

	Union

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId, SystemNumStr
	From A_ServerVirtualLines

GO

-------------------------


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Admin_Lines_Ext_Get' ))
	Drop procedure dbo.A_Admin_Lines_Ext_Get
GO

Create Procedure [dbo].A_Admin_Lines_Ext_Get
	@id	uniqueidentifier
as
begin

	Select 	
		e.Id,		
		w.Name, 
		w.Id,
		e.SystemNumStr,
		Cast ( e.Enabled as bit ) as Enabled, 
		Cast ( e.CanSimpleOut as bit ) as CanSimpleOut,
		Cast ( e.CanIp as bit ) as CanIp, 
		Cast ( e.CanAutoDial as bit ) as CanAutoDial,
		Cast ( e.CanMobile as bit ) as CanMobile, 
		e.Prefix,
		e.ExtNumber,
		e.Caption,
		e.DialType,
		e.ConnectedPBX,
		e.Type,
		e.StreamId,
		st.Name as StreamName,
		LineCode
	
	From A_ServerExtLines e 
		Inner Join A_WorkPlaces w on e.ServerID = w.ID
		Left Join A_ServerStreams st on e.StreamId = st.Id

	Where ( e.ServerID = @id ) or ( @id = '00000000-0000-0000-0000-000000000000' )

	Order By SystemNumStr
end
GO

----------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Admin_Lines_Int_Get' ))
	Drop procedure dbo.A_Admin_Lines_Int_Get
GO

Create Procedure [dbo].A_Admin_Lines_Int_Get
	@id uniqueidentifier
as
begin
   --    .
   --  0  - 
   --    -   (  CTI)

   Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
   Insert into @groups
	Select Id, Name 
	From A_Groups
   Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', '' )


   if ( @id = '00000000-0000-0000-0000-000000000000' )
   begin
	Select 
		e.Id,
		w.Name,
		w.Id,
		e.SystemNumStr,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName,
		e.BusyMode,
		e.LineCode,
		e.Translit
	FROM 
	(	
		Select 	Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit
		From A_ServerIntLines

		Union All

		Select 	Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit
		From A_ServerUsbLines
		
		Union All

		Select 	Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			StreamId,
			BusyMode,
			LineCode,
			Translit
		From A_ServerSipLines


		Union All

		Select 	Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit
		From A_ServerVirtualLines
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id

	Order By SystemNumStr
    
   end
   else
   begin
	
	Select 
		e.Id,
		w.Name,
		w.Id,
		e.SystemNumStr,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName,
		e.BusyMode,
		e.LineCode
	
	FROM 
	(	
		Select 
			Id,
			SystemNumStr, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode,
			Cast ( NULL as int ) as Translit
		From A_ServerIntLines
		
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id

	Where e.ServerId = @id
	Order By SystemNumStr
    end	

end
GO

---------------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_CallCenter_GetResourceInfo' ))
	Drop procedure dbo.A_CallCenter_GetResourceInfo
GO

Create  procedure [dbo].[A_CallCenter_GetResourceInfo]
	@minutes int,
	@dtnow datetime = null
as
begin

--  :
--  -   ( )
--  -   ()
--  -   ()
--  -    ()
--  -  ( )
--  -    ( )

--declare @minutes int
--set @minutes = 5

----------------------------------------------------------------------
--   ---------------------------------------------
----------------------------------------------------------------------
	Declare @intervalsec int 
	set @intervalsec = @minutes * 60

	if ( @dtnow is null )
		Set @dtnow = GetDate()

	Declare @dtstart DateTime
	Set @dtstart = DateAdd ( mi, - @minutes, @dtnow )

	Declare @operators table ( id uniqueidentifier )
	Insert into @operators
		Select IdUser FROM A_UserParams
		Where IsOperator = 1

	Declare @tasks table ( id uniqueidentifier, name nvarchar ( 200 ) collate database_default, IsOutput bit, projectid uniqueidentifier, projectname nvarchar ( 200 ) collate database_default)
	Insert into @tasks
		Select t.Id, t.Name, t.IsOutputTask, p.Id, p.Name 
		From A_TaskManager_Tasks t
			Inner join A_TaskManager_Projects p on t.IdProject = p.Id
		Where Active = 1 
			and Done = 0 
			and StartRunDateTime < @dtnow
			and StopRunDateTime > @dtnow
			and CreationType = 2
		order by idproject, type

	
	Declare @taskoperators table (idtask uniqueidentifier, idoperator uniqueidentifier)
	Insert into @taskoperators
		Select TaskId, OperatorId 
		From A_TaskManager_Operators taskopers
			Inner join @operators opers on taskopers.OperatorId = opers.Id

	Declare @tasklinecount table (idtask uniqueidentifier, linecount int )
	Insert into @tasklinecount
		Select TaskId, Count ( * ) 
		From A_TaskManager_TaskExtLines el
			Inner join @tasks t on t.Id = el.TaskId
		Group By TaskId
		
		Union all
	
		Select Id, IncomingCallsMaxCount
		From A_TaskManager_Tasks
		Where IsOutputTask = 0	

	Declare @extlines table ( id uniqueidentifier, name nvarchar ( 100 ) collate database_default)
	Insert into @extlines
		Select Id, SystemNumStr From A_ServerExtLines


	declare @tempopers table ( idoperator uniqueidentifier, idtask uniqueidentifier, datetimestart datetime, datetimestop datetime, LenTime float )
	Insert into @tempopers
		Select idoperator, idtask, datetimestart, datetimestop, lentime
		From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates os With ( NOLOCK )--With ( TabLock )
		Where DateTimeStop > @dtstart
		and not os.idtask is null

	declare @tempconn table ( IdConn uniqueidentifier, IdTask uniqueidentifier, IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float, IsOutput bit )
	Insert into @tempconn
		Select IdConn, IdTask, IdExtLine, DateTimeStart, DateTimeStop, LenTime, IsOutput
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections sc with ( INDEX ( idxCubeConnections_DateTimeStop ), NOLOCK ) --With ( TabLock )
		Where DateTimeStop > @dtstart


	Update @tempopers
	Set DateTimeStart = @dtstart
	Where DateTimeStart < @dtstart

	Update @tempopers
	Set DateTimeStop = @dtnow
	Where DateTimeStop > @dtnow or DateTimeStop is null

	Update @tempopers
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400

	Update @tempconn
	Set DateTimeStart = @dtstart
	Where DateTimeStart < @dtstart

	Update @tempconn
	Set DateTimeStop = @dtnow
	Where DateTimeStop > @dtnow or DateTimeStop is null

	Update @tempconn
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


	declare @output table ( Type int, Id uniqueidentifier, Val float, Name nvarchar ( 100 ) collate database_default, ExtId uniqueidentifier, ExtName nvarchar ( 100 ) collate database_default)
		

----------------------------------------------------------------------
--   -----------------------------------------------
----------------------------------------------------------------------

	Insert into @output ( Type, Id, Val )
		Select 1, IdOperator, Sum ( LenTime ) / @intervalsec * 100 as Val
		From
		(
			--   
			Select IdOperator, LenTime
			From @tempopers
	
			Union all
	
			--   
			Select id, 0
			From @operators o
		)a
			Inner join @operators o on a.IdOperator = o.Id
		Group By IdOperator


----------------------------------------------------------------------
--   ----------------------------------------------------
----------------------------------------------------------------------
	
	declare @temp51 table ( ALineId uniqueidentifier, BLineId uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float, IdChain uniqueidentifier )
	Insert into @temp51
		Select ALineId, BLineId, TimeStart, TimeStop, 0, IdChain
		From A_Stat_Connections_1x1 sc with ( Index  ( idx_StatConn_TStart_TStop ), NOLOCK ) --With ( TabLock )
		Where TimeStop > @dtstart or TimeStop is null

	Update @temp51
	Set DateTimeStart = @dtstart
	Where DateTimeStart < @dtstart

	Update @temp51
	Set DateTimeStop = @dtnow
	Where DateTimeStop > @dtnow or DateTimeStop is null

	Update @temp51
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400


	declare @temp52 table ( IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	Insert into @temp52
		Select el.Id, DateTimeStart, DateTimeStop, LenTime
		From @temp51 sc
			Inner join @extlines el on sc.ALineId = el.Id or sc.BLineId = el.Id



	declare @temp5 table ( IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	/*
	insert into @temp5
		--          A_Stat_Connections  IVR
		--       .
		Select IdExtLine, DateTimeStart, DateTimeStop, LenTime
		From @tempconn 
		Where IdConn is null and IsOutput = 1

		Union all
	
		Select IdExtLine, DateTimeStart, DateTimeStop, LenTime
		From @temp52
	*/

	--    .        .
	--   ) , )     .
	--     ,   , ( )  ( )  -  ,          ..
	--   ,                . -  ,     .

	-- c    .
	declare @temp53 table ( IdExtLine uniqueidentifier, DateTimeStart datetime, DateTimeStop datetime, LenTime float )
	insert into @temp53
		Select l.Id as IdExtLine, Min ( DateTimeStart ) as DateTimeStart, Max ( DateTimeStop ) as DateTimeStop, 0
		From @extlines l
			Inner join @temp51 sc on sc.ALineId = l.Id or sc.BLineId = l.Id
		Group by l.Id, IdChain
	
	Update @temp53
	Set LenTime = Cast ( DateTimeStop - DateTimeStart as float ) * 86400

	insert into @temp5
		--          A_Stat_Connections  IVR
		--       .
		Select IdExtLine, DateTimeStart, DateTimeStop, LenTime
		From @tempconn 
		Where IdConn is null and IsOutput = 1

		Union all

		Select * FROM @temp53
			

	Insert into @output ( Type, Id, Val )
		Select 2, IdExtLine, Sum ( LenTime ) / @intervalsec * 100 as Val
		From
		(
			Select IdExtLine, LenTime
			From @temp5

			Union all

			Select Id, 0
			From @extlines
		) a
			Inner join @extlines el on a.IdExtLine = el.Id
		Group By IdExtLine 

----------------------------------------------------------------------
--    -----------------------------------
----------------------------------------------------------------------

	declare @taskrescount table ( idtask uniqueidentifier, cnt int )
	Insert into @taskrescount 
		Select idtask, sum ( rescnt )
		From
		(
			Select idtask, linecount as rescnt
			From @tasklinecount
	
			Union all

			Select idtask, count ( * ) as rescnt
			From @taskoperators
			Group By Idtask
		)a
		Group By idtask


	Declare @tempres table ( IdTask uniqueidentifier, SumLen float )
	Insert into @tempres
		Select IdTask, Sum ( LenTime )
		From
		(
			Select IdTask, LenTime 
			From @tempopers
			
			Union all
		
			Select IdTask, LenTime
			From @tempconn
			
			Union all 
		
			Select Id, 0
			From @tasks
		)b
		Group By IdTask


	Insert into @output ( Type, Id, Val )
		Select 3, tr.IdTask, case when (cnt = 0) then 0 else SumLen / ( cnt * @intervalsec ) * 100 end as Val
		From @tempres tr
			Inner join @taskrescount trc on tr.IdTask = trc.IdTask
			Inner join @tasks t on tr.IdTask = t.Id

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

	Update o
	Set o.Name = u.Name
	From @output o, A_Users u
	Where o.Id = u.Id and o.Type = 1

	Update o
	Set o.Name = el.Name
	From @output o, @extlines el
	Where o.Id = el.Id and o.Type = 2

	Update o
	Set o.Name = t.Name,
	    o.ExtId = t.ProjectId,
	    o.ExtName = t.ProjectName
	From @output o, @tasks t
	Where o.Id = t.Id and o.Type = 3

	Update o
	Set o.Val = 100
	From @output o
	Where o.Val > 100


	Select * 
	From @output
	Order By Type, ExtName, Name

end
GO

------------------


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_CallRoutes_LoadLines' ))
	Drop procedure dbo.A_CallRoutes_LoadLines
GO


Create procedure dbo.A_CallRoutes_LoadLines	
as
begin
	Select rl.IdRoute, rl.IdLine, rl.Pos, l.SystemNumStr
	From A_CallRoutes r
		Inner join A_CallRoutes_Lines rl on r.Id = rl.IdRoute
		Inner join A_View_ServerLinesAll l on rl.IdLine = l.Id
	Order By rl.IdRoute, rl.Pos
end
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DynamicConfig_Add_ExtLine' ))
	Drop procedure dbo.A_DynamicConfig_Add_ExtLine
GO


Create procedure dbo.A_DynamicConfig_Add_ExtLine
	@lineid uniqueidentifier,
	@type int = 7,
	@caption nvarchar(200) = '',	
	@linenum int = NULL,
	@streamid uniqueidentifier,
	@linecode nvarchar(200) = '',
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@linenumstr nvarchar(10) = NULL
as
Begin
	Declare @srvid uniqueidentifier
	Set @srvid = @serverid
	if ( @srvid = '00000000-0000-0000-0000-000000000000' )
		Select @srvid = [Id] 
		From A_WorkPlaces 
		Where ( hasfastengine = 1 ) and ( ParentID = '00000000-0000-0000-0000-000000000000' )
	
	if ( @linenum is NULL )
		Set @linenum = 0
	if ( @linenumstr is NULL )
		Set @linenumstr = Cast ( @linenum as nvarchar(10))

	Insert into A_ServerExtLines ( Id, ServerId, Caption, Type, DialType, CanSimpleOut, CanIP, CanAutoDial, Prefix, SystemNum, Enabled, CanMobile, ExtNumber, ConnectedPBX, StreamId, LineCode, IsDynamicConfig, SystemNumStr )
	Values ( @lineid, @srvid, @caption, @type, 0, 1, 1, 1, '', @linenum, 1, 1, '', 0, @streamid, @linecode, 1, @linenumstr )
End
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Line_GetFreeExtLineNumberSipFrom' ))
	Drop procedure dbo.A_Line_GetFreeExtLineNumberSipFrom
GO


Create procedure dbo.A_Line_GetFreeExtLineNumberSipFrom
	@serverid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@from int = 0
as
Begin
	Declare @number int
	Set @number = 13000

	Select @number = Cast ( Min ( SystemNumStr ) as int )
	From A_ServerExtLines 
	Where ( SystemNum / 1000 % 10 = 3 ) 
		And (( ServerId = @serverid ) or ( @serverid = '00000000-0000-0000-0000-000000000000' ))

	Declare @x table (num int)

	if ( @from > 1000 )
		Set @from = @from % 1000

	while ( @from < 999 ) begin

		set @from = @from + 1
		set @number = @number / 1000 * 1000 + @from

		Insert into @x (num)		
		Values ( @number )
	end

	Select Min ( num ) as EmptyNum
	From @x x
	Where not exists ( Select SystemNumStr From A_ServerExtLines where cast ( x.Num as nvarchar(10)) like SystemNumStr)

End
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Line_GetIdByNum' ))
	Drop procedure dbo.A_Line_GetIdByNum
GO


Create Procedure [dbo].[A_Line_GetIdByNum] 	
	@num nvarchar ( 10 )	
AS
Begin
	--      

	Select Id 
	From A_View_ServerLinesAll	
	Where SystemNumStr like @num
	
End
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Line_GetLineStates' ))
	Drop procedure dbo.A_Line_GetLineStates
GO

Create Procedure dbo.A_Line_GetLineStates
as
begin
	Select ID, Enabled, Type, OwnerID, React, ServerID, reactserver, connected, SystemNum, LineCode, SystemNumStr
	From A_View_LineStates 
	Order By SystemNumStr
end
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Line_GetMaxExtLineNumberSip' ))
	Drop procedure dbo.A_Line_GetMaxExtLineNumberSip
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Line_GetNumById' ))
	Drop procedure dbo.A_Line_GetNumById
GO


Create Procedure[dbo].[A_Line_GetNumById] 
	@id uniqueidentifier	
As
Begin
	--      

	Select SystemNumStr
	From A_View_ServerLinesAll
	Where [Id] = @id
END
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Lines_Numbers_Get' ))
	Drop procedure dbo.A_Lines_Numbers_Get
GO


Create procedure [dbo].A_Lines_Numbers_Get
as
begin
--       
	
	Select Id, SystemNum, SystemNumStr
	From A_View_ServerLinesAll
	Order By SystemNumStr
end
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_MobileControl_Journal_Get' ))
	Drop procedure dbo.A_MobileControl_Journal_Get
GO


CREATE  procedure [dbo].[A_MobileControl_Journal_Get]
	@dstart 	datetime,
 	@dstop 		datetime,
 	@tstart 	datetime,
 	@tstop 		datetime,
	@number		nvarchar ( 50 ),
	@userid		uniqueidentifier
as
begin
--     

---   ---------
/*
declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare @number nvarchar ( 50 )
declare @userid uniqueidentifier


set @dstart = '2006/06/01'
set @dstop = '2006/07/19'
set @tstart = '10:11:00'
set @tstop = '12:20:00'
set @number = ''
set @userid = '00000000-0000-0000-0000-000000000000'
*/

---------------------------------

	Declare @tstartfloat float 
	Declare @tstopfloat float
	Set @tstartfloat = Convert ( float, @tstart )
	Set @tstopfloat  = Convert ( float, @tstop )
	Set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
	Set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


	--   
	Declare @chains table ( IdChain uniqueidentifier, TimeStop DateTime )
	if ( @number = '' )
		Insert into @chains
			Select IdChain, Max ( TimeStop ) as TimeStop
			From A_Stat_Connections_1x1 sc
			Where TimeStop > @dstart and TimeStart < @dstop
				and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
				and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
				--and BOutNumber like '%' + @number + '%'
			Group By IdChain
	else
		Insert into @chains
			Select IdChain, Max ( TimeStop ) as TimeStop
			From A_Stat_Connections_1x1 sc
			Where TimeStop > @dstart and TimeStart < @dstop
				and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
				and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
				and BOutNumber like '%' + @number + '%'
			Group By IdChain

	Declare @united table ( id uniqueidentifier, name nvarchar ( 100 ) collate database_default)
	Insert Into @united
		Select Id, Name From A_Users
		Union
		Select Id, ( SystemNumStr + ' ' + Caption ) as Name From A_View_ServerIntLinesDefaultUsers

	Select sc.Id as connectionid, sc.TimeStart, u.Name as username, u.Id as userid, mcd.mask, mcd.Description, sc.BOutNumber, case When mcf.mask is null then 1 else 0 end as denied, CAST ( CAST ( ch.TimeStop - sc.TimeStart as DateTime ) as float ) as Length, sc.IsRecorded, sc.IdRecDir, sc.ALineNum, sc.BLineNum--, sc.ARecFile, sc.BRecFile 
	From A_Stat_Connections_1x1 sc
		Inner Join A_MobileControlMaskDenied mcd on sc.BOutNumber like REPLACE ( mcd.mask, '?', '_' )
		Inner Join @united u on sc.AUserId = u.Id or sc.ALineId = u.Id
		Inner Join @chains ch on sc.IdChain = ch.IdChain
		Left Join A_MobileControlMaskFree mcf on sc.BOutNumber like REPLACE ( mcf.mask, '?', '_' )
	Where ( u.Id = @userid or @userid = '00000000-0000-0000-0000-000000000000' )
	Order By sc.TimeStart
End
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DB_RemoveTails' ))
	Drop procedure dbo.A_DB_RemoveTails
GO

Create  Procedure [dbo].[A_DB_RemoveTails] 
as
begin

--      .  ,    ..

		-----------------------------------------------------
		--     ------------------
		-----------------------------------------------------
		exec A_DynamicConfig_Clear

		-----------------------------------------------------
		--     -------------------
		-----------------------------------------------------

		Update dbo.A_ServerExtLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerGSMLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerIntLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerSipLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerUSBLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerVirtualLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		-----------------------------------------------------
		--    ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not ( LineId in ( Select [ID] From A_View_ServerIntLinesAll ))
		Delete From A_ServerExtLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerIntLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerGSMLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerSipLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [id] in (Select LineID From A_WORKPLACES)
		Delete From A_ServerVirtualLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		
		Delete From A_LinesReactors where not [WPID] in ( Select [id] From A_WORKPLACES )
		Delete From A_LinesReactors where not LineID in ( Select [ID] From A_View_ServerLinesAll )
		Delete From A_ServerNumbers where not [id] in ( Select [ID] From A_WorkPlaces Where type=5 )
		Delete From A_ServerNumbers where [id] in ( Select [ID] From A_WorkPlaces where hasdatabase>0 )

		Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )

		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] From A_WORKPLACES Union 
			Select [id] From A_Users union
			Select [id] From A_ExtNumbers union
			Select [id] From A_View_ServerLinesAll			

		
		Delete From A_RuleRecords where not RuleID in (Select ID From A_Rules)

		-- ,     
		Delete From A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ From @t ))
		-- ,   
		Delete From A_RuleRecords where (InnerAddressType in (3)) and ( not ReactID in (Select [Id] From A_ServerStreams ))

		Delete From A_NumberPlanAction where numtype=0 and extraid not in (Select ID From A_Rules)
		Delete From A_NumberPlan where id not in (Select numid From A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID From A_NumberPlan)
		Delete From A_Rules	Where not id in ( Select ruleid From A_RuleRecords )		

		Delete From A_TaskManager_TaskExtLines where not ExtLineId in ( Select id From A_ServerExtLines )
		Delete From A_TaskManager_Operators where not OperatorId in ( Select id From A_Users u inner join A_UserParams up on u.Id = up.IdUser Where up.IsOperator = 1 Union Select Id From C_Groups )
		Delete From A_TaskManager_TaskProperties where not IdTask in ( Select id From A_TaskManager_Tasks )

		-----------------------------------------------------
		--     =   -   
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = '  ' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null  0  ID    ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		--  0     -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		-----------------------------------------------------
		--         --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId 
			From A_View_ServerIntLinesDefaultUsers
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 From @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerVirtualLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		--    ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id From C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id From @uidt)
			or not UserB in (Select id From @uidt)

		-----------------------------------------------------
		--     --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		--  , ,   -------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		exec A_Admin_Number_SiftByActions
		
		exec A_Admin_Rule_SiftByNumbers
		
		-----------------------------------------------------
		--  - ---------------------
		-----------------------------------------------------
		Delete From A_PluginMenu_User
		Where not exists ( Select Id From A_Users u Where u.Id = A_PluginMenu_User.IdUser )

		-----------------------------------------------------
		--   ------------------------------
		-----------------------------------------------------	
		Delete from A_WorkPlace_Address

end
GO

---------------------

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_BeforeLoad' ))
	Drop procedure dbo.A_BeforeLoad
GO

Create procedure dbo.A_BeforeLoad
as
begin
	Declare @x int
end
GO

----------------------